<!DOCTYPE html>

<html lang="en" data-content_root="../../">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>birdshot.birdshot &#8212; birdshot 0.0.post1.dev20+g168d24e.d20231220 documentation</title>
    <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=fa44fd50" />
    <link rel="stylesheet" type="text/css" href="../../_static/alabaster.css?v=233b9934" />
    <script src="../../_static/documentation_options.js?v=c5a7b33d"></script>
    <script src="../../_static/doctools.js?v=888ff710"></script>
    <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
   
  <link rel="stylesheet" href="../../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <h1>Source code for birdshot.birdshot</h1><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">__future__</span> <span class="kn">import</span> <span class="n">annotations</span>

<span class="kn">import</span> <span class="nn">json</span>
<span class="kn">import</span> <span class="nn">logging</span>
<span class="kn">import</span> <span class="nn">networkx</span> <span class="k">as</span> <span class="nn">nx</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">re</span>
<span class="kn">import</span> <span class="nn">requests</span>
<span class="kn">import</span> <span class="nn">statistics</span>
<span class="kn">import</span> <span class="nn">warnings</span>

<span class="kn">from</span> <span class="nn">carta_integrations.google.drive</span> <span class="kn">import</span> <span class="n">GDrive</span>
<span class="kn">from</span> <span class="nn">collections</span> <span class="kn">import</span> <span class="n">defaultdict</span><span class="p">,</span> <span class="n">namedtuple</span>
<span class="kn">from</span> <span class="nn">collections.abc</span> <span class="kn">import</span> <span class="n">Hashable</span>
<span class="kn">from</span> <span class="nn">flatten_json</span> <span class="kn">import</span> <span class="n">flatten_preserve_lists</span>
<span class="kn">from</span> <span class="nn">pathlib</span> <span class="kn">import</span> <span class="n">Path</span>
<span class="kn">from</span> <span class="nn">pydantic</span> <span class="kn">import</span> <span class="n">BaseModel</span><span class="p">,</span> <span class="n">Field</span><span class="p">,</span> <span class="n">ConfigDict</span>
<span class="kn">from</span> <span class="nn">pydantic</span> <span class="kn">import</span> <span class="n">field_serializer</span>
<span class="kn">from</span> <span class="nn">scipy</span> <span class="kn">import</span> <span class="n">stats</span>
<span class="kn">from</span> <span class="nn">typing</span> <span class="kn">import</span> <span class="n">Any</span><span class="p">,</span> <span class="n">Callable</span><span class="p">,</span> <span class="n">Optional</span><span class="p">,</span> <span class="n">Union</span>
<span class="kn">from</span> <span class="nn">uuid</span> <span class="kn">import</span> <span class="n">uuid4</span>
<span class="k">try</span><span class="p">:</span>
    <span class="kn">from</span> <span class="nn">pycarta.auth</span> <span class="kn">import</span> <span class="n">AuthorizationAgent</span>
    <span class="kn">from</span> <span class="nn">pycarta.api</span> <span class="kn">import</span> <span class="n">CartaObjectStorage</span>
<span class="k">except</span><span class="p">:</span>
    <span class="n">msg</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot;</span>
<span class="s2">        pycarta could not be imported. The version of pycarta currently</span>
<span class="s2">        published on PyPi is incompatible with this package. pycarta should be</span>
<span class="s2">        installed using a wheel installation from the most recent version.</span>
<span class="s2">        &quot;&quot;&quot;</span>
    <span class="n">logging</span><span class="o">.</span><span class="n">error</span><span class="p">(</span><span class="n">msg</span><span class="p">)</span>
    <span class="k">raise</span> <span class="ne">ImportError</span><span class="p">(</span><span class="n">msg</span><span class="p">)</span>


<span class="c1"># This does not handle the recursive content checking</span>
<span class="c1"># needed for a full definition of JSON types.</span>
<span class="n">JsonType</span> <span class="o">=</span> <span class="n">Union</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="nb">float</span><span class="p">,</span> <span class="nb">int</span><span class="p">,</span> <span class="kc">None</span><span class="p">,</span> <span class="nb">list</span><span class="p">[</span><span class="n">Any</span><span class="p">],</span> <span class="nb">dict</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">Any</span><span class="p">]]</span>


<div class="viewcode-block" id="Birdshot">
<a class="viewcode-back" href="../../api/birdshot.html#birdshot.birdshot.Birdshot">[docs]</a>
<span class="k">class</span> <span class="nc">Birdshot</span><span class="p">(</span><span class="n">GDrive</span><span class="p">):</span>
<div class="viewcode-block" id="Birdshot.Property">
<a class="viewcode-back" href="../../api/birdshot.html#birdshot.birdshot.Birdshot.Property">[docs]</a>
    <span class="k">class</span> <span class="nc">Property</span><span class="p">(</span><span class="n">BaseModel</span><span class="p">,</span> <span class="n">Hashable</span><span class="p">):</span>
        <span class="nb">id</span><span class="p">:</span> <span class="nb">str</span><span class="o">=</span><span class="n">Field</span><span class="p">(</span><span class="n">default_factory</span><span class="o">=</span><span class="p">(</span><span class="k">lambda</span><span class="p">:</span> <span class="nb">str</span><span class="p">(</span><span class="n">uuid4</span><span class="p">())))</span>
        <span class="n">name</span><span class="p">:</span> <span class="nb">str</span>
        <span class="n">value</span><span class="p">:</span> <span class="n">Any</span>
        <span class="k">def</span> <span class="fm">__hash__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
            <span class="k">return</span> <span class="nb">hash</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">id</span><span class="p">)</span></div>

        
<div class="viewcode-block" id="Birdshot.Entry">
<a class="viewcode-back" href="../../api/birdshot.html#birdshot.birdshot.Birdshot.Entry">[docs]</a>
    <span class="k">class</span> <span class="nc">Entry</span><span class="p">(</span><span class="n">GDrive</span><span class="o">.</span><span class="n">Entry</span><span class="p">,</span> <span class="n">BaseModel</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        The eponymous Entry is a file or folder inside a FileSystem, including</span>
<span class="sd">        Google Drive. This class extends the functionality of the Entry to</span>
<span class="sd">        interact with data stored in Google Drive as part of the Birdshot</span>
<span class="sd">        program.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># model_config = ConfigDict(arbitrary_types_allowed=True)</span>

        <span class="n">properties</span><span class="p">:</span> <span class="nb">dict</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="nb">set</span><span class="p">[</span><span class="n">Birdshot</span><span class="o">.</span><span class="n">Property</span><span class="p">]]</span><span class="o">=</span><span class="n">Field</span><span class="p">(</span><span class="n">default_factory</span><span class="o">=</span><span class="p">(</span><span class="k">lambda</span><span class="p">:</span> <span class="n">defaultdict</span><span class="p">(</span><span class="nb">set</span><span class="p">)))</span>
        <span class="c1"># serialize the properties field</span>
<div class="viewcode-block" id="Birdshot.Entry.serialize_properties">
<a class="viewcode-back" href="../../api/birdshot.html#birdshot.birdshot.Birdshot.Entry.serialize_properties">[docs]</a>
        <span class="nd">@field_serializer</span><span class="p">(</span><span class="s1">&#39;properties&#39;</span><span class="p">)</span>
        <span class="k">def</span> <span class="nf">serialize_properties</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">prop</span><span class="p">:</span> <span class="nb">dict</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="nb">set</span><span class="p">[</span><span class="n">Birdshot</span><span class="o">.</span><span class="n">Property</span><span class="p">]],</span> <span class="n">_info</span><span class="p">):</span>
            <span class="k">return</span> <span class="p">{</span>
                <span class="n">key</span><span class="p">:[</span><span class="n">x</span><span class="o">.</span><span class="n">model_dump</span><span class="p">()</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">value</span><span class="p">]</span>
                <span class="k">for</span> <span class="n">key</span><span class="p">,</span> <span class="n">value</span> <span class="ow">in</span> <span class="n">prop</span><span class="o">.</span><span class="n">items</span><span class="p">()</span>
            <span class="p">}</span></div>

        <span class="c1"># load the contents of this entry</span>
<div class="viewcode-block" id="Birdshot.Entry.load">
<a class="viewcode-back" href="../../api/birdshot.html#birdshot.birdshot.Birdshot.Entry.load">[docs]</a>
        <span class="k">def</span> <span class="nf">load</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">interface</span><span class="p">:</span> <span class="n">Birdshot</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="kc">None</span><span class="p">:</span>
<span class="w">            </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">            Load the contents of a file as properties into an entry. At present</span>
<span class="sd">            only JSON-formatted content is supported.</span>

<span class="sd">            We know we&#39;re in Google Drive, so rely on the metadata present in</span>
<span class="sd">            the Google Drive query.</span>

<span class="sd">            Parameters</span>
<span class="sd">            ----------</span>
<span class="sd">            agent: Birdshot</span>
<span class="sd">                Althought a class nested within the Birdshot class, the Entry</span>
<span class="sd">                class does not have access to member variables in Birdshot.</span>
<span class="sd">                Therefore, `load` must be passed an agent to mediate</span>
<span class="sd">                communication with Google Drive.</span>

<span class="sd">            Returns</span>
<span class="sd">            -------</span>
<span class="sd">            None</span>
<span class="sd">            &quot;&quot;&quot;</span>
            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">metadata</span><span class="p">[</span><span class="s2">&quot;mimeType&quot;</span><span class="p">]</span> <span class="o">==</span> <span class="s2">&quot;application/json&quot;</span><span class="p">:</span>
                <span class="n">payload</span> <span class="o">=</span> <span class="n">json</span><span class="o">.</span><span class="n">loads</span><span class="p">(</span><span class="n">interface</span><span class="o">.</span><span class="n">read</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span><span class="o">.</span><span class="n">getvalue</span><span class="p">())</span>
                <span class="n">flattened</span> <span class="o">=</span> <span class="n">flatten_preserve_lists</span><span class="p">(</span><span class="n">payload</span><span class="p">)</span>
                <span class="k">if</span> <span class="ow">not</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">flattened</span><span class="p">,</span> <span class="nb">list</span><span class="p">):</span>
                    <span class="n">flattened</span> <span class="o">=</span> <span class="p">[</span><span class="n">flattened</span><span class="p">]</span>
                <span class="k">for</span> <span class="n">flat</span> <span class="ow">in</span> <span class="n">flattened</span><span class="p">:</span>
                    <span class="k">if</span> <span class="ow">not</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">flat</span><span class="p">,</span> <span class="nb">dict</span><span class="p">):</span>
                        <span class="c1"># Only dictionaries can be handled/converted into properties</span>
                        <span class="n">logging</span><span class="o">.</span><span class="n">warning</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Invalid content in </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="si">!r}</span><span class="s2"> was skipped.&quot;</span><span class="p">)</span>
                        <span class="k">continue</span>
                    <span class="k">for</span> <span class="n">key</span><span class="p">,</span> <span class="n">value</span> <span class="ow">in</span> <span class="n">flat</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
                        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="n">value</span><span class="p">,</span> <span class="s2">&quot;__iter__&quot;</span><span class="p">)</span> <span class="ow">or</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">value</span><span class="p">,</span> <span class="nb">str</span><span class="p">):</span>
                            <span class="c1"># ensure we are working with a list.</span>
                            <span class="n">value</span> <span class="o">=</span> <span class="p">[</span><span class="n">value</span><span class="p">]</span>
                        <span class="bp">self</span><span class="o">.</span><span class="n">properties</span><span class="p">[</span><span class="n">key</span><span class="p">]</span><span class="o">.</span><span class="n">update</span><span class="p">([</span><span class="n">Birdshot</span><span class="o">.</span><span class="n">Property</span><span class="p">(</span><span class="n">name</span><span class="o">=</span><span class="n">key</span><span class="p">,</span> <span class="n">value</span><span class="o">=</span><span class="n">v</span><span class="p">)</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">value</span><span class="p">])</span></div>

        <span class="c1"># property reductions</span>
<div class="viewcode-block" id="Birdshot.Entry.apply_to_properties">
<a class="viewcode-back" href="../../api/birdshot.html#birdshot.birdshot.Birdshot.Entry.apply_to_properties">[docs]</a>
        <span class="k">def</span> <span class="nf">apply_to_properties</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span>
            <span class="n">fn</span><span class="p">:</span> <span class="n">Callable</span><span class="p">,</span>
            <span class="o">*</span><span class="p">,</span>
            <span class="n">suffix</span><span class="p">:</span> <span class="nb">str</span> <span class="o">|</span> <span class="kc">None</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
            <span class="n">include</span><span class="p">:</span> <span class="nb">str</span> <span class="o">|</span> <span class="kc">None</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
            <span class="n">exclude</span><span class="p">:</span> <span class="nb">str</span> <span class="o">|</span> <span class="kc">None</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
            <span class="n">cast</span><span class="p">:</span> <span class="nb">type</span> <span class="o">|</span> <span class="kc">None</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
            <span class="n">default</span><span class="p">:</span> <span class="n">Any</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
            <span class="n">raise_on_error</span><span class="p">:</span> <span class="nb">bool</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
            <span class="n">replace</span><span class="p">:</span> <span class="nb">bool</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
            <span class="n">fallback</span><span class="p">:</span> <span class="n">Callable</span> <span class="o">|</span> <span class="kc">None</span><span class="o">=</span><span class="kc">None</span>
        <span class="p">)</span> <span class="o">-&gt;</span> <span class="kc">None</span><span class="p">:</span>
<span class="w">            </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">            Apply a callable to the list of properties.</span>

<span class="sd">            Parameters</span>
<span class="sd">            ----------</span>
<span class="sd">            fn : Callable</span>
<span class="sd">                Function-like object that accepts an unordered list of values.</span>
<span class="sd">            </span>
<span class="sd">            suffix : str (optional)</span>
<span class="sd">                An optional string to append to the property key name when</span>
<span class="sd">                storing the results of the function operation. Default: None;</span>
<span class="sd">                that is, the result of the operation overwrites the property by</span>
<span class="sd">                default.</span>
<span class="sd">            include : str (optional)</span>
<span class="sd">                A regular expression can be used to include specific (matching)</span>
<span class="sd">                properties. Default: Include all properties.</span>
<span class="sd">            exclude : str (optional)</span>
<span class="sd">                A regular expression can be used to exclude specific (matching)</span>
<span class="sd">                properties. See examples. Default: Exclude no properties.</span>
<span class="sd">            cast : type (optional)</span>
<span class="sd">                Cast the values to a specific type.</span>
<span class="sd">            default : Any (optional)</span>
<span class="sd">                If not None, use this, the default value, if the cast fails. If</span>
<span class="sd">                default = None and the cast fails, the value is returned</span>
<span class="sd">                unchanged.</span>
<span class="sd">            raise_on_error : bool (optional)</span>
<span class="sd">                If False (default), then any operation failure that raises an</span>
<span class="sd">                exception excludes that property from the set of results. If</span>
<span class="sd">                True, then no changes are made to the set of properties if an</span>
<span class="sd">                error occurs while applying the operation.</span>
<span class="sd">            replace : bool (optional)</span>
<span class="sd">                If False (default), then the result of the function updates the</span>
<span class="sd">                the set of properties. If True, then the result of the function</span>
<span class="sd">                replaces the existing properties.</span>
<span class="sd">            fallback : callable (optional)</span>
<span class="sd">                Function to call should the first fail.</span>

<span class="sd">            Returns</span>
<span class="sd">            -------</span>
<span class="sd">            None</span>

<span class="sd">            Examples</span>
<span class="sd">            --------</span>

<span class="sd">                # Initiate &quot;entry&quot;, an instance of Birdshot.Entry, with</span>
<span class="sd">                # numerical properties.</span>

<span class="sd">                # The following performs a series of reductions, but excludes</span>
<span class="sd">                # previously calculated values with the suffix &quot;_.*&quot;</span>
<span class="sd">                entry.apply_to_properties(np.mean, suffix=&quot;_mean&quot;, exclude=&quot;_.*&quot;)</span>
<span class="sd">                entry.apply_to_properties(np.std, suffix=&quot;_std&quot;, exclude=&quot;_.*&quot;)</span>
<span class="sd">            &quot;&quot;&quot;</span>
            <span class="k">def</span> <span class="nf">cast_</span><span class="p">(</span><span class="n">x</span><span class="p">):</span>
                <span class="k">if</span> <span class="n">cast</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                    <span class="k">try</span><span class="p">:</span>
                        <span class="k">return</span> <span class="n">cast</span><span class="p">(</span><span class="n">x</span><span class="p">)</span>
                    <span class="k">except</span><span class="p">:</span>
                        <span class="k">if</span> <span class="n">default</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                            <span class="k">return</span> <span class="n">default</span>
                        <span class="k">else</span><span class="p">:</span>
                            <span class="k">return</span> <span class="n">x</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="k">return</span> <span class="n">x</span>
                
            <span class="c1"># which properties should be included and which should not.</span>
            <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">include</span><span class="p">,</span> <span class="nb">str</span><span class="p">):</span>
                <span class="n">include</span> <span class="o">=</span> <span class="p">[</span><span class="n">key</span> <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">properties</span> <span class="k">if</span> <span class="n">re</span><span class="o">.</span><span class="n">match</span><span class="p">(</span><span class="n">include</span><span class="p">,</span> <span class="n">key</span><span class="p">)]</span>
            <span class="n">include</span> <span class="o">=</span> <span class="nb">set</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">properties</span> <span class="k">if</span> <span class="n">include</span> <span class="ow">is</span> <span class="kc">None</span> <span class="k">else</span> <span class="n">include</span><span class="p">)</span>
            <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">exclude</span><span class="p">,</span> <span class="nb">str</span><span class="p">):</span>
                <span class="n">exclude</span> <span class="o">=</span> <span class="p">[</span><span class="n">key</span> <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">properties</span> <span class="k">if</span> <span class="n">re</span><span class="o">.</span><span class="n">match</span><span class="p">(</span><span class="n">exclude</span><span class="p">,</span> <span class="n">key</span><span class="p">)]</span>
            <span class="n">include</span> <span class="o">-=</span> <span class="nb">set</span><span class="p">([]</span> <span class="k">if</span> <span class="n">exclude</span> <span class="ow">is</span> <span class="kc">None</span> <span class="k">else</span> <span class="n">exclude</span><span class="p">)</span>
            <span class="n">logging</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Including properties </span><span class="si">{</span><span class="n">include</span><span class="si">!r}</span><span class="s2">.&quot;</span><span class="p">)</span>
            <span class="c1"># process</span>
            <span class="n">result</span> <span class="o">=</span> <span class="n">defaultdict</span><span class="p">(</span><span class="nb">set</span><span class="p">)</span>
            <span class="c1"># for key, propset in self.properties.items():</span>
            <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="n">include</span><span class="p">:</span>
                <span class="k">try</span><span class="p">:</span>
                    <span class="n">propset</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">properties</span><span class="p">[</span><span class="n">key</span><span class="p">]</span>
                <span class="k">except</span> <span class="ne">KeyError</span><span class="p">:</span>
                    <span class="n">logging</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">key</span><span class="si">!r}</span><span class="s2"> not found in the set of properties.&quot;</span><span class="p">)</span>
                    <span class="k">if</span> <span class="n">raise_on_error</span><span class="p">:</span>
                        <span class="k">raise</span> <span class="ne">KeyError</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">key</span><span class="si">!r}</span><span class="s2"> is not a recognized property.&quot;</span><span class="p">)</span>
                    <span class="k">else</span><span class="p">:</span>
                        <span class="k">continue</span>
                <span class="n">arr</span> <span class="o">=</span> <span class="p">[</span><span class="n">cast_</span><span class="p">(</span><span class="n">p</span><span class="o">.</span><span class="n">value</span><span class="p">)</span> <span class="k">for</span> <span class="n">p</span> <span class="ow">in</span> <span class="n">propset</span><span class="p">]</span>
                <span class="n">newKey</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">key</span><span class="si">}{</span><span class="n">suffix</span><span class="si">}</span><span class="s2">&quot;</span> <span class="k">if</span> <span class="n">suffix</span> <span class="k">else</span> <span class="n">key</span>
                <span class="k">try</span><span class="p">:</span>
                    <span class="n">value</span> <span class="o">=</span> <span class="n">fn</span><span class="p">(</span><span class="n">arr</span><span class="p">)</span>
                    <span class="n">result</span><span class="p">[</span><span class="n">newKey</span><span class="p">]</span> <span class="o">=</span> <span class="p">{</span><span class="n">Birdshot</span><span class="o">.</span><span class="n">Property</span><span class="p">(</span><span class="n">name</span><span class="o">=</span><span class="n">newKey</span><span class="p">,</span> <span class="n">value</span><span class="o">=</span><span class="n">value</span><span class="p">)}</span>
                    <span class="n">logging</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">fn</span><span class="o">.</span><span class="vm">__name__</span><span class="si">}</span><span class="s2">(</span><span class="si">{</span><span class="n">key</span><span class="si">}</span><span class="s2">) success (</span><span class="si">{</span><span class="n">value</span><span class="si">}</span><span class="s2">).&quot;</span><span class="p">)</span>
                <span class="k">except</span> <span class="ne">Exception</span> <span class="k">as</span> <span class="n">e</span><span class="p">:</span>
                        <span class="k">if</span> <span class="n">fallback</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                            <span class="k">try</span><span class="p">:</span>
                                <span class="n">value</span> <span class="o">=</span> <span class="n">fallback</span><span class="p">(</span><span class="n">arr</span><span class="p">)</span>
                                <span class="n">result</span><span class="p">[</span><span class="n">newKey</span><span class="p">]</span> <span class="o">=</span> <span class="p">{</span><span class="n">Birdshot</span><span class="o">.</span><span class="n">Property</span><span class="p">(</span><span class="n">name</span><span class="o">=</span><span class="n">newKey</span><span class="p">,</span> <span class="n">value</span><span class="o">=</span><span class="n">value</span><span class="p">)}</span>
                                <span class="n">logging</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">fallback</span><span class="o">.</span><span class="vm">__name__</span><span class="si">}</span><span class="s2">(</span><span class="si">{</span><span class="n">key</span><span class="si">}</span><span class="s2">) success (</span><span class="si">{</span><span class="n">value</span><span class="si">}</span><span class="s2">).&quot;</span><span class="p">)</span>
                            <span class="k">except</span><span class="p">:</span>
                                <span class="n">logging</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">fn</span><span class="o">.</span><span class="vm">__name__</span><span class="p">,</span><span class="w"> </span><span class="n">fallback</span><span class="o">.</span><span class="vm">__name__</span><span class="si">}</span><span class="s2">(</span><span class="si">{</span><span class="n">key</span><span class="si">}</span><span class="s2">: </span><span class="si">{</span><span class="n">arr</span><span class="si">}</span><span class="s2">) failed.&quot;</span><span class="p">)</span>
                                <span class="k">if</span> <span class="n">raise_on_error</span><span class="p">:</span>
                                    <span class="k">raise</span>
                        <span class="k">else</span><span class="p">:</span>
                            <span class="n">logging</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">fn</span><span class="o">.</span><span class="vm">__name__</span><span class="si">}</span><span class="s2">(</span><span class="si">{</span><span class="n">key</span><span class="si">}</span><span class="s2">: </span><span class="si">{</span><span class="n">arr</span><span class="si">}</span><span class="s2">) failed.&quot;</span><span class="p">)</span>
                            <span class="k">if</span> <span class="n">raise_on_error</span><span class="p">:</span>
                                <span class="k">raise</span> <span class="n">e</span>
            <span class="c1"># save the result in the properties map</span>
            <span class="k">if</span> <span class="n">replace</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">properties</span> <span class="o">=</span> <span class="n">result</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">properties</span><span class="o">.</span><span class="n">update</span><span class="p">(</span><span class="n">result</span><span class="p">)</span></div>


<div class="viewcode-block" id="Birdshot.Entry.central_tendency">
<a class="viewcode-back" href="../../api/birdshot.html#birdshot.birdshot.Birdshot.Entry.central_tendency">[docs]</a>
        <span class="k">def</span> <span class="nf">central_tendency</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
<span class="w">            </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">            Automatically identify the central tendency in order: mean, mode</span>
<span class="sd">            &quot;&quot;&quot;</span>
            <span class="n">opts</span> <span class="o">=</span> <span class="n">kwds</span><span class="o">.</span><span class="n">copy</span><span class="p">()</span>
            <span class="n">opts</span><span class="p">[</span><span class="s2">&quot;fallback&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">statistics</span><span class="o">.</span><span class="n">mode</span>
            <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">apply_to_properties</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">mean</span><span class="p">,</span> <span class="o">**</span><span class="n">opts</span><span class="p">)</span></div>

        
<div class="viewcode-block" id="Birdshot.Entry.drop">
<a class="viewcode-back" href="../../api/birdshot.html#birdshot.birdshot.Birdshot.Entry.drop">[docs]</a>
        <span class="k">def</span> <span class="nf">drop</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
            <span class="n">include</span> <span class="o">=</span> <span class="n">kwds</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;include&quot;</span><span class="p">,</span> <span class="nb">set</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">properties</span><span class="o">.</span><span class="n">keys</span><span class="p">()))</span>
            <span class="n">include</span> <span class="o">-=</span> <span class="n">kwds</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;exclude&quot;</span><span class="p">,</span> <span class="nb">set</span><span class="p">())</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">properties</span> <span class="o">=</span> <span class="p">{</span><span class="n">k</span><span class="p">:</span><span class="n">v</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span><span class="n">v</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">properties</span><span class="o">.</span><span class="n">items</span><span class="p">()</span> <span class="k">if</span> <span class="n">k</span> <span class="ow">in</span> <span class="n">include</span><span class="p">}</span></div>

<div class="viewcode-block" id="Birdshot.Entry.mean">
<a class="viewcode-back" href="../../api/birdshot.html#birdshot.birdshot.Birdshot.Entry.mean">[docs]</a>
        <span class="k">def</span> <span class="nf">mean</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
            <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">apply_to_properties</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">mean</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">)</span></div>

<div class="viewcode-block" id="Birdshot.Entry.median">
<a class="viewcode-back" href="../../api/birdshot.html#birdshot.birdshot.Birdshot.Entry.median">[docs]</a>
        <span class="k">def</span> <span class="nf">median</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
            <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">apply_to_properties</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">median</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">)</span></div>

<div class="viewcode-block" id="Birdshot.Entry.mode">
<a class="viewcode-back" href="../../api/birdshot.html#birdshot.birdshot.Birdshot.Entry.mode">[docs]</a>
        <span class="k">def</span> <span class="nf">mode</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
            <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">apply_to_properties</span><span class="p">(</span><span class="n">statistics</span><span class="o">.</span><span class="n">mode</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">)</span></div>

<div class="viewcode-block" id="Birdshot.Entry.std">
<a class="viewcode-back" href="../../api/birdshot.html#birdshot.birdshot.Birdshot.Entry.std">[docs]</a>
        <span class="k">def</span> <span class="nf">std</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
            <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">apply_to_properties</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">std</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">)</span></div>

<div class="viewcode-block" id="Birdshot.Entry.variance">
<a class="viewcode-back" href="../../api/birdshot.html#birdshot.birdshot.Birdshot.Entry.variance">[docs]</a>
        <span class="k">def</span> <span class="nf">variance</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
            <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">apply_to_properties</span><span class="p">(</span><span class="n">statistics</span><span class="o">.</span><span class="n">variance</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">)</span></div>

<div class="viewcode-block" id="Birdshot.Entry.inner_quartile_range">
<a class="viewcode-back" href="../../api/birdshot.html#birdshot.birdshot.Birdshot.Entry.inner_quartile_range">[docs]</a>
        <span class="k">def</span> <span class="nf">inner_quartile_range</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
            <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">apply_to_properties</span><span class="p">(</span><span class="n">stats</span><span class="o">.</span><span class="n">iqr</span><span class="p">)</span></div>
</div>

    <span class="c1"># END: class Entry(GDrive.Entry, BaseModel)</span>

    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">username</span><span class="p">,</span> <span class="n">password</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">url</span> <span class="p">:</span> <span class="nb">str</span><span class="p">):</span>
        <span class="c1"># Log in to Carta</span>
        <span class="n">agent</span> <span class="o">=</span> <span class="n">AuthorizationAgent</span><span class="p">(</span><span class="n">username</span><span class="p">,</span> <span class="n">password</span><span class="p">,</span> <span class="n">url</span><span class="o">=</span><span class="n">url</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">agent</span> <span class="o">=</span> <span class="n">agent</span>
        <span class="c1"># Retrieve Google Drive secret from dispatcher.</span>
        <span class="n">credentials</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_get_google_drive_credentials</span><span class="p">()</span>
        <span class="c1"># Use the Google Drive credentials retrieved from Carta to setup</span>
        <span class="c1"># the Google Drive access agent.</span>
        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="n">service_account_info</span><span class="o">=</span><span class="n">credentials</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">cartaObjectStorage</span> <span class="o">=</span> <span class="n">CartaObjectStorage</span><span class="p">(</span><span class="n">agent</span><span class="p">)</span>
        <span class="c1"># State variables</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_graph</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_root</span> <span class="o">=</span> <span class="n">namedtuple</span><span class="p">(</span><span class="s2">&quot;EmptyRoot&quot;</span><span class="p">,</span> <span class="s2">&quot;id&quot;</span><span class="p">)(</span><span class="kc">None</span><span class="p">)</span>
    
    <span class="k">def</span> <span class="nf">_get_google_drive_credentials</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">JsonType</span><span class="p">:</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Retrieves the Google Drive credentials.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">service_</span><span class="o">=</span> <span class="k">lambda</span> <span class="n">endpoint</span><span class="p">:</span> <span class="sa">f</span><span class="s2">&quot;service/birdshot/htmdec/</span><span class="si">{</span><span class="n">endpoint</span><span class="si">}</span><span class="s2">&quot;</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">response</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">agent</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">service_</span><span class="p">(</span><span class="s2">&quot;check&quot;</span><span class="p">))</span>
            <span class="n">response</span><span class="o">.</span><span class="n">raise_for_status</span><span class="p">()</span>
        <span class="k">except</span> <span class="n">requests</span><span class="o">.</span><span class="n">exceptions</span><span class="o">.</span><span class="n">HTTPError</span> <span class="k">as</span> <span class="n">e</span><span class="p">:</span>
            <span class="n">e</span><span class="o">.</span><span class="n">response</span><span class="o">.</span><span class="n">reason</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;No access to </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">agent</span><span class="o">.</span><span class="n">url</span><span class="si">}</span><span class="s2">/</span><span class="si">{</span><span class="n">service_</span><span class="p">(</span><span class="s1">&#39;&#39;</span><span class="p">)</span><span class="si">}</span><span class="s2">.&quot;</span>
            <span class="k">raise</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">response</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">agent</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">service_</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;credentials/get?resource=google-drive&quot;</span><span class="p">))</span>
            <span class="n">response</span><span class="o">.</span><span class="n">raise_for_status</span><span class="p">()</span>
        <span class="k">except</span> <span class="n">requests</span><span class="o">.</span><span class="n">exceptions</span><span class="o">.</span><span class="n">HTTPError</span> <span class="k">as</span> <span class="n">e</span><span class="p">:</span>
            <span class="n">e</span><span class="o">.</span><span class="n">response</span><span class="o">.</span><span class="n">reason</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;Failed to access the BIRDSHOT resource credentials for Google Drive.&quot;</span>
            <span class="k">raise</span>
        <span class="k">return</span> <span class="n">response</span><span class="o">.</span><span class="n">json</span><span class="p">()</span>
    
    <span class="nd">@property</span>
    <span class="k">def</span> <span class="nf">project</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="c1"># The BIRDSHOT project has only one project</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">cartaObjectStorage</span><span class="o">.</span><span class="n">projects</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
    
    <span class="nd">@property</span>
    <span class="k">def</span> <span class="nf">connection</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="c1"># The BIRDSHOT project has only one connection</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">cartaObjectStorage</span><span class="o">.</span><span class="n">connections</span><span class="p">[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span>

<div class="viewcode-block" id="Birdshot.build_graph">
<a class="viewcode-back" href="../../api/birdshot.html#birdshot.birdshot.Birdshot.build_graph">[docs]</a>
    <span class="k">def</span> <span class="nf">build_graph</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">rootId</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Google Drive exposes a list function that is much faster than</span>
<span class="sd">        iterating through nodes sequentially.</span>

<span class="sd">        Note: This method does not change the state of the instance but,</span>
<span class="sd">        instead, is intended to build graphs from a given node ID. If you want</span>
<span class="sd">        to set the graph available in an instance graph, see</span>
<span class="sd">        `Birdshot.graph(nodeId)`.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        rootId : str</span>
<span class="sd">            File ID of the root node in the graph. If not given, this is the</span>
<span class="sd">            project connection root</span>
<span class="sd">        </span>
<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">rootId</span> <span class="o">=</span> <span class="n">rootId</span> <span class="ow">or</span> <span class="bp">self</span><span class="o">.</span><span class="n">connection</span><span class="o">.</span><span class="n">root</span><span class="o">.</span><span class="n">nativeId</span><span class="o">.</span><span class="n">fileId</span>
        <span class="n">G</span> <span class="o">=</span> <span class="n">nx</span><span class="o">.</span><span class="n">DiGraph</span><span class="p">()</span>
        <span class="c1"># Get files (a.k.a. Nodes)</span>
        <span class="n">FILES</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">gds</span><span class="o">.</span><span class="n">files</span><span class="p">()</span>
        <span class="n">nextPageToken</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="n">logging</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="s2">&quot;Downloading available files/folders from Google Drive.&quot;</span><span class="p">)</span>
        <span class="k">while</span> <span class="kc">True</span><span class="p">:</span>
            <span class="n">logging</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Fetching next page of entries using page token: </span><span class="si">{</span><span class="n">nextPageToken</span><span class="si">!r}</span><span class="s2">.&quot;</span><span class="p">)</span>
            <span class="c1"># All files accessible with this API key are of interest.</span>
            <span class="n">response</span> <span class="o">=</span> <span class="n">FILES</span><span class="o">.</span><span class="n">list</span><span class="p">(</span>
                <span class="n">corpora</span><span class="o">=</span><span class="s2">&quot;user&quot;</span><span class="p">,</span>
                <span class="n">q</span><span class="o">=</span><span class="sa">f</span><span class="s2">&quot;trashed = false&quot;</span><span class="p">,</span>
                <span class="n">fields</span><span class="o">=</span><span class="s2">&quot;*&quot;</span><span class="p">,</span>
                <span class="n">includeItemsFromAllDrives</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
                <span class="n">supportsAllDrives</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
                <span class="n">pageToken</span><span class="o">=</span><span class="n">nextPageToken</span><span class="p">,</span>
                <span class="n">pageSize</span><span class="o">=</span><span class="mi">50</span><span class="p">)</span><span class="o">.</span><span class="n">execute</span><span class="p">()</span>
            <span class="c1"># Add the set of nodes just read.</span>
            <span class="n">G</span><span class="o">.</span><span class="n">add_nodes_from</span><span class="p">([</span>
                <span class="n">Birdshot</span><span class="o">.</span><span class="n">Entry</span><span class="p">(</span><span class="nb">id</span><span class="o">=</span><span class="n">f</span><span class="o">.</span><span class="n">pop</span><span class="p">(</span><span class="s2">&quot;id&quot;</span><span class="p">),</span> <span class="n">metadata</span><span class="o">=</span><span class="n">f</span><span class="p">,</span> <span class="n">parent</span><span class="o">=</span><span class="bp">self</span><span class="p">)</span>
                <span class="k">for</span> <span class="n">f</span> <span class="ow">in</span> <span class="n">response</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;files&quot;</span><span class="p">,</span> <span class="p">[])</span>
            <span class="p">])</span>
            <span class="n">nextPageToken</span> <span class="o">=</span> <span class="n">response</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;nextPageToken&quot;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
            <span class="k">if</span> <span class="ow">not</span> <span class="n">nextPageToken</span><span class="p">:</span>
                <span class="k">break</span>
        <span class="n">logging</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Read </span><span class="si">{</span><span class="nb">len</span><span class="p">(</span><span class="n">G</span><span class="p">)</span><span class="si">}</span><span class="s2"> files (nodes) from BIRDSHOT.&quot;</span><span class="p">)</span>
        <span class="c1"># Add the edges</span>
        <span class="n">logging</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="s2">&quot;Adding edges to graph.&quot;</span><span class="p">)</span>
        <span class="n">nodeMap</span> <span class="o">=</span> <span class="p">{</span><span class="n">n</span><span class="o">.</span><span class="n">id</span><span class="p">:</span><span class="n">n</span> <span class="k">for</span> <span class="n">n</span> <span class="ow">in</span> <span class="n">G</span><span class="o">.</span><span class="n">nodes</span><span class="p">}</span>
        <span class="k">for</span> <span class="n">child</span> <span class="ow">in</span> <span class="n">G</span><span class="o">.</span><span class="n">nodes</span><span class="p">:</span>
            <span class="k">try</span><span class="p">:</span>
                <span class="n">G</span><span class="o">.</span><span class="n">add_edges_from</span><span class="p">([</span>
                    <span class="p">(</span><span class="n">nodeMap</span><span class="p">[</span><span class="n">parentId</span><span class="p">],</span> <span class="n">child</span><span class="p">)</span> <span class="k">for</span> <span class="n">parentId</span>
                    <span class="ow">in</span> <span class="n">child</span><span class="o">.</span><span class="n">metadata</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;parents&quot;</span><span class="p">,</span> <span class="p">[])</span>
                <span class="p">])</span>
            <span class="k">except</span> <span class="ne">KeyError</span><span class="p">:</span>
                <span class="c1"># The check is expensive. Only check if the previous attempt</span>
                <span class="c1"># fails. This should only happen at the root, whose parent</span>
                <span class="c1"># is inaccessible to the current user.</span>
                <span class="n">logging</span><span class="o">.</span><span class="n">warning</span><span class="p">(</span>
                    <span class="sa">f</span><span class="s2">&quot;One of the nodes in </span><span class="si">{</span><span class="n">child</span><span class="o">.</span><span class="n">metadata</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;parents&#39;</span><span class="p">,</span><span class="w"> </span><span class="p">[])</span><span class="si">}</span><span class="s2"> &quot;</span>
                    <span class="sa">f</span><span class="s2">&quot;was not found in Google Drive. User may not have &quot;</span>
                    <span class="sa">f</span><span class="s2">&quot;permission to access the enclosing folder.&quot;</span><span class="p">)</span>
                <span class="n">G</span><span class="o">.</span><span class="n">add_edges_from</span><span class="p">([</span>
                    <span class="p">(</span><span class="n">nodeMap</span><span class="p">[</span><span class="n">parentId</span><span class="p">],</span> <span class="n">child</span><span class="p">)</span> <span class="k">for</span> <span class="n">parentId</span>
                    <span class="ow">in</span> <span class="n">child</span><span class="o">.</span><span class="n">metadata</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;parents&quot;</span><span class="p">,</span> <span class="p">[])</span>
                    <span class="k">if</span> <span class="n">parentId</span> <span class="ow">in</span> <span class="n">nodeMap</span>
                <span class="p">])</span>
        <span class="c1"># NOTE: The following was failing in the sandbox account because the</span>
        <span class="c1"># root&#39;s parent is not accessible to the sandbox user or the rootId</span>
        <span class="c1"># is incorrect in this connection.</span>
        <span class="c1"># Build the edges from the nodes, starting at the root.</span>
        <span class="c1"># logging.debug(&quot;Adding edges to graph.&quot;)</span>
        <span class="c1"># try:</span>
        <span class="c1">#     queue = [nodeMap[rootId]]</span>
        <span class="c1"># except KeyError:</span>
        <span class="c1">#     msg = f&quot;Did not find the project root ({rootId!r}) in Google Drive.&quot;</span>
        <span class="c1">#     logging.error(msg)</span>
        <span class="c1">#     raise KeyError(msg)</span>
        <span class="c1"># while True:</span>
        <span class="c1">#     # Get parent</span>
        <span class="c1">#     try:</span>
        <span class="c1">#         # this performs a preorder construction of the graph.</span>
        <span class="c1">#         parent = queue.pop()</span>
        <span class="c1">#     except IndexError:</span>
        <span class="c1">#         break</span>
        <span class="c1">#     children = [n.id for n in G.nodes</span>
        <span class="c1">#                 if parent in n.metadata.get(&quot;parents&quot;, [])]</span>
        <span class="c1">#     queue.extend(children)</span>
        <span class="c1">#     G.add_edges_from([</span>
        <span class="c1">#         (nodeMap[parent], nodeMap[child]) for child in children])</span>
        <span class="c1"># Create a new graph that keeps only those nodes that are connected to</span>
        <span class="c1"># the root</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">roots</span> <span class="o">=</span> <span class="p">[</span><span class="n">nodeMap</span><span class="p">[</span><span class="n">rootId</span><span class="p">]]</span>
        <span class="k">except</span> <span class="ne">KeyError</span><span class="p">:</span>
            <span class="n">roots</span> <span class="o">=</span> <span class="p">[</span><span class="n">n</span> <span class="k">for</span> <span class="n">n</span> <span class="ow">in</span> <span class="n">G</span><span class="o">.</span><span class="n">nodes</span> <span class="k">if</span> <span class="n">G</span><span class="o">.</span><span class="n">in_degree</span><span class="p">(</span><span class="n">n</span><span class="p">)</span> <span class="o">==</span> <span class="mi">0</span><span class="p">]</span>
        <span class="n">edges</span> <span class="o">=</span> <span class="p">[(</span><span class="n">parent</span><span class="p">,</span> <span class="n">child</span><span class="p">)</span>
                 <span class="k">for</span> <span class="n">root</span> <span class="ow">in</span> <span class="n">roots</span>
                 <span class="k">for</span> <span class="n">parent</span> <span class="ow">in</span> <span class="n">nx</span><span class="o">.</span><span class="n">dfs_preorder_nodes</span><span class="p">(</span><span class="n">G</span><span class="p">,</span> <span class="n">root</span><span class="p">)</span>
                 <span class="k">for</span> <span class="n">child</span> <span class="ow">in</span> <span class="n">G</span><span class="o">.</span><span class="n">successors</span><span class="p">(</span><span class="n">parent</span><span class="p">)]</span>
        <span class="n">result</span> <span class="o">=</span> <span class="n">nx</span><span class="o">.</span><span class="n">DiGraph</span><span class="p">()</span>
        <span class="n">result</span><span class="o">.</span><span class="n">add_edges_from</span><span class="p">(</span><span class="nb">list</span><span class="p">(</span><span class="nb">set</span><span class="p">(</span><span class="n">edges</span><span class="p">)))</span>
        <span class="c1"># Done</span>
        <span class="n">logging</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="s2">&quot;Finished building graph.&quot;</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">namedtuple</span><span class="p">(</span><span class="s2">&quot;BuildGraph&quot;</span><span class="p">,</span> <span class="s2">&quot;graph root&quot;</span><span class="p">)(</span><span class="n">result</span><span class="p">,</span> <span class="n">nodeMap</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">rootId</span><span class="p">,</span> <span class="n">roots</span><span class="p">))</span></div>


    <span class="nd">@property</span>
    <span class="k">def</span> <span class="nf">G</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">_graph</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">_graph</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">_root</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">build_graph</span><span class="p">()</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_graph</span>
    
    <span class="nd">@property</span>
    <span class="k">def</span> <span class="nf">root</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Root node of the current graph.</span>
<span class="sd">        </span>
<span class="sd">        Note: this is the node document retrieved from Google and structured</span>
<span class="sd">        as a Node. The ID (e.g., &quot;nativeId&quot;) of this node can be retrieved as</span>
<span class="sd">        `&lt;Birdshot instance&gt;.root.id`.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_root</span>
    
<div class="viewcode-block" id="Birdshot.graph">
<a class="viewcode-back" href="../../api/birdshot.html#birdshot.birdshot.Birdshot.graph">[docs]</a>
    <span class="k">def</span> <span class="nf">graph</span><span class="p">(</span>
        <span class="bp">self</span><span class="p">,</span>
        <span class="n">fileId</span> <span class="p">:</span> <span class="n">Union</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">Path</span><span class="p">,</span> <span class="n">Birdshot</span><span class="o">.</span><span class="n">Entry</span><span class="p">]</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
        <span class="n">graph</span> <span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">nx</span><span class="o">.</span><span class="n">DiGraph</span><span class="p">]</span><span class="o">=</span><span class="kc">None</span>
    <span class="p">)</span> <span class="o">-&gt;</span> <span class="n">nx</span><span class="o">.</span><span class="n">DiGraph</span><span class="p">:</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Within Google Drive it is easier to build the graph by retrieving all</span>
<span class="sd">        available nodes and building the graph from the specified root.</span>

<span class="sd">        If `fileId` is given, this forces a rebuild of the graph. Therefore, to</span>
<span class="sd">        force a rebuild of the project graph:</span>

<span class="sd">            birdshot = Birdshot(&lt;username&gt;, &lt;password&gt;)</span>
<span class="sd">            ...</span>
<span class="sd">            birdshot.graph(birdshot.root.id)</span>

<span class="sd">        To access the graph itself, use `birdshot.G` (`birdshot` is a</span>
<span class="sd">        `Birdshot` instance, as above).</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        fileId : str | Path | Birdshot.Entry</span>
<span class="sd">            The root node. If not specified, use the root node for this project</span>
<span class="sd">            connection.</span>
<span class="sd">        graph : networkx.DiGraph</span>
<span class="sd">            Unnecessary in this function. Kept here to maintain API</span>
<span class="sd">            compatibility with the base class.</span>
<span class="sd">        </span>
<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        networkx.DiGraph</span>
<span class="sd">            The graph of the resource structure.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="n">fileId</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">warnings</span><span class="o">.</span><span class="n">warn</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Retrieving graph rooted at </span><span class="si">{</span><span class="n">fileId</span><span class="si">!r}</span><span class="s2">. This may take a while.&quot;</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">_graph</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">_root</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">build_graph</span><span class="p">(</span><span class="n">fileId</span><span class="p">)</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">G</span></div>
</div>

</pre></div>

          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../index.html">birdshot</a></h1>








<h3>Navigation</h3>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../readme.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../cli.html">CLI</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../contributing.html">Contributions &amp; Help</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../license.html">License</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../authors.html">Authors</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../changelog.html">Changelog</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../api/modules.html">Module Reference</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../index.html">Documentation overview</a><ul>
  <li><a href="../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2023, Contextualize LLC.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 7.2.6</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.13</a>
      
    </div>

    

    
  </body>
</html>